using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Threading;
using System.Web;
using System.Web.Services;
using System.Xml.Serialization;

namespace GrBoard
{
	/// <summary>
	/// fւ̉摜f[^̓o^T[rX
	/// </summary>
	public class ContributionService : System.Web.Services.WebService
	{
		const int INVALIDATE_MSEC = -3000;
		const int MAX_ARTICLES = 16;

		static private Random random = new Random();
		static private Thread monitor;

		public ContributionService()
		{
			//CODEGEN: ̌ĂяóAASP.NET Web T[rX fUCiŕKvłB
			InitializeComponent();

		}

		#region R|[lg fUCiŐꂽR[h 
		
		//Web T[rX fUCiŕKvłB
		private IContainer components = null;
				
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// ContributionService
			// 

		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		/// <summary>
		/// e\񂷂B
		/// </summary>
		/// <returns>l̓rW[</returns>
		[WebMethod]
		public int Reserve()
		{
			Hashtable contributions = (Hashtable)Application["contributions"];
			lock(contributions.SyncRoot)
			{
				for (int i = 0; i < 100; i++)
				{
					int n = random.Next();
					if (!contributions.ContainsKey(n))
					{
						StartMonitor();
						contributions.Add(n, DateTime.Now);
						return n;
					}
				}
			}
			return -1;
		}

		/// <summary>
		/// e󂯕tB
		/// </summary>
		/// <param name="reservedKey">sςݗ\L[</param>
		/// <param name="contrib">ee</param>
		[WebMethod]
		public void Register(int reservedKey, Contribution contrib)
		{
			Debug.Assert(Application["contributions"] != null, "no contribution array");
			Debug.Assert(Application["articles"] is ArrayList, "articles not initialized");

			Article a = null;
			// \񂳂ĂȂΖB
			Hashtable contributions = (Hashtable)Application["contributions"];
			if (contributions.ContainsKey(reservedKey))
			{
				// ۂɂ͂̎_Monitorɂč폜Ă\B
				// Ao^ς݃L[Ă̂Â܂ܓo^͌pB
				lock(contributions.SyncRoot)
				{
					contributions.Remove(reservedKey);
				}
				ArrayList list = (ArrayList)Application["articles"];
				lock (list.SyncRoot)
				{
					// KAArrayListւ̊i[DateTimȅԏƂȂ悤ɁA
					// ArrayListbNĂԂɃCX^X̐Ɠo^sB
					a = new Article();
					list.Add(a);
					if (list.Count > MAX_ARTICLES)
					{
						list.RemoveAt(0);
					}
				}
				Debug.Assert(a != null, "can't instantiate");
			}
			if (a != null)
			{
				// C[W̐sB
				a.Setup(contrib);
			}
		}

		private void StartMonitor()
		{
			// contributionsbN
			if (monitor == null)
			{
				monitor = new Thread(new ThreadStart(Monitor));
				monitor.Start();
			}				
		}

		// Ԑ؂ƂȂ\L[폜B
		public void Monitor()
		{
			Hashtable contributions = (Hashtable)Application["contributions"];
			for (;;)
			{
				Thread.Sleep(1000);
				DateTime now = DateTime.Now;
				now.AddSeconds(INVALIDATE_MSEC);
				lock(contributions.SyncRoot)
				{
					if (contributions.Count == 0)
					{
						monitor = null;
						break;
					}
					ArrayList dels = new ArrayList();
					foreach (DictionaryEntry e in contributions)
					{
						DateTime d = (DateTime)e.Value;
						if (d < now)
						{
							dels.Add(e.Key);
						}
					}
					foreach (int k in dels)
					{
						contributions.Remove(k);
					}
				}
			}
		}

	}
}
